  /***********/
 /* GLAVA.H */
/***********/

#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/types.h>
#include <time.h> //Ognjen, staro: #include <sys/time.h>
#include <string.h>

// RADI SE O SERIJSKOJ VERZIJI GA, A NE O PGA
//#include <thread.h>

typedef unsigned long UL;

#define MAX_VPOP   1000 //Ognjen: promijenio sa 300 na 1000 radi potreba eksperimenta
#define MAXBUF   1024
#define MAXSLUC   32767
#define MAXZ 1200
#define MAXP 30

#define RND15 (UL)( rand() & MAXSLUC )
#define RND30 (UL)( RND15 | (RND15 << 15) )
#define DO_JEDAN   RND15 / 32767.0

extern int Z,P;
extern float T[];
extern int *RP;
extern int MAX_GEN,V_POP,M,PM,BR_DRETVI;
extern int BR_B,rbr_fje,DIM,br_toc,BR_VRSTA,NISP;
extern char *ime_dat, fispis[];
extern long rbr_gen;

extern char *ime_izl_dat; //Ognjen: dodao za potrebu grafickog prikaza rasporeda
extern long BrJednakiRoditelji; //Ognjen: dodao za brojanje slucaja da su roditelji jednaki

extern void init_sluc(void);
extern UL sluc(UL);
extern double sluc(double,double);
extern int broj(char *);
extern void ucitaj_parametre(void);
extern void ispisi_parametre(void);
extern void ispisi_long(long);
extern void vrsta(void);

struct KROMOSOM{
public:
   int mbr;            // mbr kromososma
   int z,p,*k;  // broj zadataka i procesora, kromosom
   double fx;
   KROMOSOM(void);
   KROMOSOM(const KROMOSOM &); //Ognjen: dodao copy konstruktor
   ~KROMOSOM(void);
   void ispisi(void);
   void ispisi_detaljno(void); //Ognjen: dodao za potrebu grafickog prikaza rasporeda
   void operator =(const KROMOSOM &);
   KROMOSOM operator +(KROMOSOM &); // krizanje
   void operator <=(int);           // mutacija
   void evaluiraj(void);
private:
   void umetni(int,int);
   void izbaci(int,int);
   int gdje_je(int);
};

class POPULACIJA{
   int VEL_POP,min,dobri[MAX_VPOP],losi[MAX_VPOP];
   // dobrota i kumulativna vjerojatnost eliminacije
   double dobrota[MAX_VPOP],kve[MAX_VPOP];
public:
   KROMOSOM *a[MAX_VPOP];
   POPULACIJA(int);
   ~POPULACIJA();
   void ispisi(void);
   int najbolji(void);
   void TurnirGA(void);
   void Zivite_i_mnozite_se(void);
};
extern POPULACIJA *p;

class Text_file{
   FILE *fp;
   char buf[MAXBUF+1];
public:
   Text_file(const char *ime_datoteke,const char *tip){
      if( (fp=fopen(ime_datoteke,tip))==NULL ){
         printf("Ne mogu otvoriti datoteku %s !\n",ime_datoteke);
         exit(1);
      }
   }
   ~Text_file(void){ fclose(fp); }

   char *Uzmi(void){
      if( fgets(buf,MAXBUF,fp) != NULL ) return buf;
      return NULL;
   }
   void Spremi(char *s){ fputs(s,fp); }
};
